#include "CM.h"


void CM_Init(void)
{
    cmd_flg_firstRun = true;
}

void CM(void)
{
    static uint16_T cmn_V_cellUMax;
    static uint16_T cmn_V_cellUMin;
    static uint16_T chrgFulCnt;
    static boolean_T cmn_flg_chrgFul;
    static uint16_T chrgCnt;
    static uint16_T noChrgCnt;
    uint16_T cmd_I_chrgCurrReq1 = 0;
    uint16_T cmd_I_chrgCurrReq2 = 0;
    uint16_T cmd_I_chrgCurrReq3 = 0;
    uint16_T cmd_I_chrgCurrReq4 = 0;
	static boolean_T First;
    static uint8_T cmd_st_chrgSt_end;
	static boolean_T chrgFul;
    if(cmd_flg_firstRun)
    {
        cmn_V_cellUMax = 0;
        cmn_V_cellUMin = 0;
        chrgFulCnt = 0;
        chrgCnt = 0;
        noChrgCnt = 0;
        cmn_flg_chrgFul = false;
		cmd_st_chrgSt = 0;
		chrgFul = 0;
    }
    //=====================================================================
    //============================充电模式=================================
    //=====================================================================
    if(ihd_st_chrgConnect > 0)
    {
        cmd_st_chrgMod = 1;
    }
    else
    {
        cmd_st_chrgMod = 0;
    }
	
    //=====================================================================
    //============================充电需求电流=============================
    //=====================================================================
    if (cmd_st_chrgMod)
    {
        if(sfmd_V_cellUMin > cmn_V_cellUMin)
        {
            cmn_V_cellUMin = sfmd_V_cellUMin;
        }
        if(sfmd_V_cellUMax > cmn_V_cellUMax)
        {
            cmn_V_cellUMax = sfmd_V_cellUMax;
        }
        cmd_I_chrgCurrReq1 = look2_u16u16tu16(cmn_V_cellUMin,sfmd_T_modTMin,cmm_V_ChrgCurr,cmm_T_ChrgCurr,cmm_I_ChrgCurr,6,3);
        cmd_I_chrgCurrReq2 = look2_u16u16tu16(cmn_V_cellUMax,sfmd_T_modTMin,cmm_V_ChrgCurr,cmm_T_ChrgCurr,cmm_I_ChrgCurr,6,3);
        cmd_I_chrgCurrReq3 = look2_u16u16tu16(cmn_V_cellUMin,sfmd_T_modTMax,cmm_V_ChrgCurr,cmm_T_ChrgCurr,cmm_I_ChrgCurr,6,3);
        cmd_I_chrgCurrReq4 = look2_u16u16tu16(cmn_V_cellUMax,sfmd_T_modTMax,cmm_V_ChrgCurr,cmm_T_ChrgCurr,cmm_I_ChrgCurr,6,3);
		cmd_I_chrgCurrReq =  min( min(cmd_I_chrgCurrReq1, cmd_I_chrgCurrReq2),min(cmd_I_chrgCurrReq3,cmd_I_chrgCurrReq4));
    }
    else
    {
        cmd_I_chrgCurrReq = 0;
    }
	
    //=====================================================================
    //============================充电状态=================================
    //=====================================================================
    if (cmd_st_chrgMod > 0)
    {
        noChrgCnt = 0; 
        if (sfmd_I_curr > 1)
        {
            cmd_st_chrgSt = 1;
        } 
		if(JudgeTimeSystem(1,sfmd_V_cellUMax >= cmnc_V_chrgFul ,&chrgFulCnt ,20))
		{
		   chrgFul = true;
           cmn_flg_chrgFul = true;
		} 
        if(cmn_flg_chrgFul)
        {
            cmd_st_chrgSt = 2;
            cmd_I_chrgCurrReq = 0;
        }

		//
        if (cmd_st_chrgSt != 2 && JudgeTimeSystem(1,sfmd_I_curr < 1 ,&chrgCnt ,100) )
        {
            cmd_st_chrgSt = 3;
            cmd_I_chrgCurrReq = 0;
        }
		//
        if((sfmd_st_fltAct >> 6) & 0x01)
        {
            cmd_st_chrgSt = 3;
            cmd_I_chrgCurrReq = 0; 
        }




		
		cmd_st_chrgSt_end = cmd_st_chrgSt;
    }
    else
    {   
        cmn_flg_chrgFul = false;
        chrgCnt = 0;
        noChrgCnt ++;
        if(cmd_st_chrgSt_end == 1  && noChrgCnt <= 100 )
        {
            cmd_st_chrgSt = 3;
        }
        else
        {
            cmd_st_chrgSt = 0;
        }
    }
	
    // ===================================================================
    // =================故障结束原因========================================
    // ===================================================================
    if(cmd_st_chrgSt == 3 )
    {
        if (ihd_st_chrgConnect == 0 && First)
        {
            cmd_idx_chrgEndReason = 1 ; // 用户主动停止
        }
        if((sfmd_st_fltAct >> 6) & 0x01 && First)
        {
            cmd_idx_chrgEndReason = 2 ; // 因电池故障限制充电；
        }

        First = false;
    }
    else
    {
        First = true ;
        cmd_idx_chrgEndReason = 0;
    }

    cmd_flg_firstRun = false;
	//printf("fltAct:%d,chrgMod:%d,chrgSt:%d,chrgCurrReq:%d,chrgEndReason:%d\n\n",sfmd_st_fltAct,cmd_st_chrgMod,cmd_st_chrgSt,cmd_I_chrgCurrReq,cmd_idx_chrgEndReason);
}


//==============================================================================================================================
//==============================================================================================================================

